
function fxImpactSnow();
function fxBulletImpact(ENTITY* bullet);
function fxShot(ENTITY* w);
function fxGas();
function fxSound(SOUND* sound,var vol);
function fxSoundNear();
function fxSoundDie();
function fxEnemieDie(ENTITY* enemy);
function fxEnemieSnow();

SOUND* sOpening="opening.wav";

SOUND* m1="m1.wav";
SOUND* m2="m2.wav";
SOUND* m3="m3.wav";
SOUND* m4="m4.wav";
SOUND* m5="m5.wav";

SOUND* mGameoverLoop="gameoverLoop.ogg";
SOUND* mMenuLoop="menuLoop.wav";

SOUND* sGameover="gameover.wav";
SOUND* sButton="button.wav";
SOUND* sStep="step.wav";
SOUND* sShot="shot.wav";
SOUND* sHit="hit.wav";

SOUND* sNear1="near1.wav";
SOUND* sNear2="near2.wav";
SOUND* sNear3="near3.wav";
SOUND* sNear4="near4.wav";

SOUND* sDie1="die1.wav";
SOUND* sDie2="die2.wav";

SOUND* sLevelUp="levelUp.wav";

function fxImpactSnow(){
	vec_scale(my.scale_x,random(2)+0.25);
	set(my,PASSABLE);
	vec_set(my.pan,vector(random(360)-180,random(180)-90,0));
	
	var speed[3],temp1[3];
	vec_for_angle(speed,my.pan);
	vec_scale(speed,-random(50));
	vec_rotate(speed,vector(random(360)-180,random(180)-90,0));
	
	while(vec_length(speed)>0.1){
		vec_set(temp1,speed);
		vec_scale(temp1,time_frame);
		vec_add(my.x,temp1);
		
		if(my.z<0){
			vec_scale(speed,0.1+random(0.8));
			speed[2]*=-1;
			my.z=1;
		}
		speed[2]-=5*time_frame;
		wait(1);
	}
	ent_remove(me);
}

function fxBulletImpact(ENTITY* bullet){
	fxSound(sHit,15);
	
	int i;
	for(i=0;i<20;i++){
		ent_create("snow.mdl",bullet.x,fxImpactSnow);
	}
}

function fxShot(ENTITY* w){
	var i;
	var temp1[3];
	
	fxSound(sShot,100);	
	
	vec_set(temp1,vector(25,0,21));
	vec_rotate(temp1,w.pan);
	vec_add(temp1,w.x);
	
	for(i=0;i<10;i++){
		you=ent_create("gas.tga",temp1,fxGas);
		vec_set(you.pan,w.pan);
	}
	
	for(i=0;i<5;i++){
		you=ent_create("gas.tga",temp1,fxGas);
		vec_set(you.pan,w.pan);
		you.pan-=90;
	}
	
	var anm=0;
	while(anm<100&&player.health>0){
		ent_animate(w,"shot",anm,ANM_CYCLE);
		anm+=50*time_frame;
		wait(1);
	}
}

function fxGas(){
	set(my,PASSABLE | TRANSLUCENT | BRIGHT);
	vec_scale(my.scale_x,random(0.2)+0.1);
	wait(1);
	my.tilt=90;
	
	var speed[3];
	var temp1[3];
	vec_set(speed,vector(random(100),0,0));
	vec_rotate(speed,vector(my.pan+random(40)-20,0,0));
	my.pan=random(360)-180;
	my.alpha=20+random(20);
	
	while(my.alpha>0){
		vec_set(temp1,speed);
		vec_scale(temp1,time_frame);
		vec_add(my.x,temp1);
		vec_scale(temp1,0.8);
		my.alpha-=30*time_frame;		
		wait(1);
	}
	ent_remove(me);
}


function fxSound(SOUND* sound,var vol){
	var s;
	
	s=snd_play(sound,vol,0);
	snd_tune(s,0,95+random(10),0);
}

function fxSoundNear(){
	SOUND* s;
	
	switch(integer(random(4))){
		case 0:s=sNear1;break;
		case 1:s=sNear2;break;
		case 2:s=sNear3;break;
		case 3:s=sNear4;break;
		default:s=sNear1;break;
	}
	
	fxSound(s,50);
}

function fxSoundDie(){
	SOUND* s;
	
	switch(integer(random(2))){
		case 0:s=sDie1;break;
		case 1:s=sDie2;break;
		default:s=sDie1;break;
	}
	
	fxSound(s,50);
}


function fxEnemieDie(ENTITY* enemy){
	fxSoundDie();
	
	int i;
	for(i=0;i<30;i++){
		ent_create("snow.mdl",enemy.x,fxEnemieSnow);
	}
}


function fxEnemieSnow(){
	vec_scale(my.scale_x,random(7.5)+2);
	set(my,PASSABLE);
	vec_set(my.pan,vector(random(360)-180,random(180)-90,0));
	
	var speed[3],temp1[3];
	vec_for_angle(speed,my.pan);
	vec_scale(speed,-random(30));
	vec_rotate(speed,vector(random(360)-180,random(180)-90,0));
	
	while(vec_length(speed)>0.1){
		vec_set(temp1,speed);
		vec_scale(temp1,time_frame);
		vec_add(my.x,temp1);
		
		if(my.z<0){
			vec_scale(speed,0.1+random(0.4));
			speed[2]*=-1;
			my.z=1;
		}
		speed[2]-=5*time_frame;
		wait(1);
	}
	ent_remove(me);
}
