
#include "player.c"
#include "enemy.c"

function gameCreate();
function gameStart();
function gameLoop();
function gameRestart();
function playMusic();
function hideControlsPanel();


function gameCreate(){
	level_load("map0.wmb");
	wait(32);
	level_mark();
	wait(32);
	
	set(controlsPanel,VISIBLE);
	controlsPanel.alpha=100;
	
	while(snd_playing(opening))
	wait(1);
	gameStart();
}

function gameStart(){
	playerCreate(vector(0,0,32));
	gameLoop();	
	set(scorePanel,VISIBLE);
}

function gameLoop(){
	int i,alive;
	var temp1[3];
	
	hideControlsPanel();
	
	for(i=0;i<5;i++){
		enemies[i]=	0;
	}
	
	while(1){
		while(player.health>0){		
			for(i=0;i<minv(1+enemiesKilled/33,5);i++){
				alive=0;
				if(enemies[i]!=NULL){
					if(enemies[i].health>0)
					alive=1;
				}
				if(!alive){
					vec_set(temp1,vector(400+random(200),0,0));
					vec_rotate(temp1,vector(random(360)-180,0,0));
					vec_add(temp1,player.x);
					temp1[2]=48;
					
					enemies[i]=enemyCreate(temp1);
				}
			}
			
			if(!snd_playing(music))
			playMusic();
			
			wait(1);
		}
		
		if(snd_playing(music))
		snd_stop(music);
		
		snd_play(sGameover,100,0);
		music=snd_loop(mGameoverLoop,50,0);
		
		set(gameOverPanel,VISIBLE);
		reset(scorePanel,VISIBLE);
		
		int i;
		for(i=0;i<5;i++){
			if(enemies[i]!=NULL)
			ent_remove(enemies[i]);
			enemies[i]=0;
		}
		
		set(bckPanel,VISIBLE); 
		bckPanel.alpha=0;
		set(gameOverText,VISIBLE);
		set(gameOverScorePanel,VISIBLE);
		gameOverText.alpha=0;
		gameOverScorePanel.alpha=0;
		
		wait(-2);
		
		while(bckPanel.alpha<50){
			bckPanel.alpha+=10*time_frame;
			wait(1);
		}
		
		while(gameOverText.alpha<100){
			gameOverText.alpha+=10*time_frame;
			gameOverScorePanel.alpha=gameOverText.alpha;
			wait(1);
		}
		
		set(restartPanel,VISIBLE);
		var n=0;
		while(!key_space){
			n+=time_frame;
			restartPanel.alpha=30-cos(20*n)*20;
			wait(1);
		}
		
		snd_stop(music);
		
		reset(gameOverText,VISIBLE);
		reset(gameOverScorePanel,VISIBLE);
		reset(restartPanel,VISIBLE);
		reset(bckPanel,VISIBLE);
		reset(gameOverPanel,VISIBLE);
		set(scorePanel,VISIBLE);
		
		enemiesKilled=0;
		playerLevel=0;
		playerCreate(vector(0,0,32));
	}
	
}


function playMusic(){
	SOUND* m;
	
	switch((int)enemiesKilled/25){
		case 0:m=m1;break;
		case 1:m=m2;break;
		case 2:m=m3;break;
		case 3:m=m4;break;
		case 4:m=m5;break;
		default:m=m5;break;
	}
	
	music=snd_play(m,30,0);
}

function hideControlsPanel(){
	while(enemiesKilled<1)
	wait(1);
	
	while(controlsPanel.alpha>0){
		controlsPanel.alpha-=5*time_frame;
		wait(1);
	}
	reset(controlsPanel,VISIBLE);
}
