
#include "actor.c"

function playerCreate(VECTOR* pos);
function playerInput();
function playerCamera();
function playerLoop();
function playerWeapon();
function weaponBullet();
function playerScore();


function playerCreate(VECTOR* pos){
	me=actorCreate("player.mdl",pos);
	player=me;
	set(me,FLAG2);
	my.typ=TYPE_PLAYER;
	my.reloadtime=4;
	my.fullauto=1;
	my.scatter=10;
	my.bulletSpeed=60;
	my.damage=20;
	
	my.weapon=ent_create("weapon.mdl",my.x,0);
	you=my.weapon;
	set(you,PASSABLE);
	
	playerInput();
	playerCamera();
	playerLoop();
}

function playerInput(){
	var temp1[3],temp2[3];
	
	while(1){
		my.inputX=key_w-key_s;
		my.inputY=key_a-key_d;
		my.inputShot=mouse_left;
		
		vec_set(temp1,vector(mouse_pos.x+32,mouse_pos.y+32,2000));
		vec_for_screen(temp1,camera);
		
		c_trace(camera.x,temp1,IGNORE_MODELS|IGNORE_PASSABLE|IGNORE_SPRITES|USE_POLYGON);
		if(trace_hit){
			vec_set(temp1,target.x);
			vec_sub(temp1,my.x);
			vec_to_angle(temp2,temp1);
			my.inputPan=temp2[0];
		}
		
		wait(1);
	}
}

function playerCamera(){
	var temp1[3];
	camera.arc=90;
	camera.tilt=-90;
	
	while(my.health>0){
		vec_set(temp1,vector(2*mouse_cursor.y/screen_size.y-1,2*mouse_cursor.x/screen_size.x-1,0));
		vec_scale(temp1,-128);
		vec_add(temp1,my.x);
		temp1[2]+=400;
		
		vec_sub(temp1,camera.x);
		vec_scale(temp1,0.075);
		vec_add(camera.x,temp1);
		
		wait(1);
	}
}

function playerLoop(){
	var step=0;
	
	while(my.health>0){
		playerWeapon();	
		step+=vec_length(my.speedX)*time_frame;
		if(step>6){
			step=0;
			fxSound(sStep,40);
		}
		
		wait(1);
	}
	
	you=my.weapon;
	ent_remove(you);
}


function playerWeapon(){
	you=my.weapon;
	vec_set(you.x,my.x);
	vec_set(you.pan,my.pan);
	
	if(!my.released&&!my.inputShot)
	my.released=1;
	
	if(my.reload<my.reloadtime)	
	my.reload+=time_frame;
	
	if(my.inputShot&&my.reload>=my.reloadtime&&my.released){
		my.reload=0;
		if(!my.fullauto)
		my.released=0;
		
		var temp1[3];
		
		vec_set(temp1,vector(40,0,20));
		vec_rotate(temp1,my.pan);
		vec_add(temp1,my.x);
		you=ent_create("bullet.mdl",temp1,weaponBullet);
		set(you,PASSABLE);
		you.pan=my.pan;
		vec_add(you.pan,vector(random(2*my.scatter)-my.scatter,0,0));
		vec_set(temp1,vector(-0.75,0,0));
		vec_rotate(temp1,my.pan);
		vec_add(my.speedX,temp1);
		if(vec_length(my.speedX)>1)
		vec_normalize(my.speedX,1);
		
		you=my.weapon;
		fxShot(you);
	}
}

function weaponBullet(){
	wait(1);
	
	var speed[3],temp1[3];
	var age=0;
	
	vec_set(speed,vector(1,0,0));
	vec_rotate(speed,my.pan);
	
	while(vec_length(speed)>0.5){
		vec_set(temp1,speed);
		vec_scale(temp1,time_frame*player.bulletSpeed);
		vec_add(temp1,my.x);
		c_trace(my.x,temp1,IGNORE_ME|IGNORE_PASSABLE|IGNORE_SPRITES|USE_BOX|IGNORE_FLAG2);
		if(trace_hit){
			if(you){
				if(you.typ==TYPE_ENEMY&&you.health>0){
					you.health-=player.damage+random(player.damage);
					vec_scale(you.speedX,0);
					if(you.health<=0){						
						playerScore();
						fxEnemieDie(you);
					}
				}
			}	
			vec_set(speed,nullvector);
			age=100;	
			fxBulletImpact(me);
			vec_set(my.x,target.x);	
		}
		else
		vec_set(my.x,temp1);
		
		vec_set(temp1,speed);
		vec_scale(temp1,-time_frame*0.1*0.5);
		vec_add(speed,temp1);
		age+=time_frame;
		wait(1);
	}
	
	my.alpha=100;
	set(my,TRANSLUCENT);
	
	while(my.alpha>0){
		my.alpha=maxv(my.alpha-100*time_frame,0);
		wait(1);
	}
	wait(-5);
	ent_remove(me);
}

function playerScore(){
	enemiesKilled+=1;
	if(enemiesKilled%10==0&&playerLevel<15){
		playerLevel++;
		switch(playerLevel){
			case 1:
			player.scatter-=1;
			break;
			case 2:
			player.bulletSpeed+=10;
			break;
			case 3:
			player.reloadtime-=0.5;
			break;
			case 4:
			player.scatter-=1;
			break;
			case 5:
			player.reloadtime-=0.5;
			break;
			case 6:
			player.reloadtime-=0.25;
			break;
			case 7:
			player.scatter-=1;
			break;
			case 8:
			player.bulletSpeed+=10;
			break;
			case 9:
			player.reloadtime-=0.25;
			break;
			case 10:
			player.bulletSpeed+=10;
			break;
			case 11:
			player.reloadtime-=0.25;
			break;
			case 12:
			player.damage+=10;
			break;
			case 13:
			player.reloadtime-=0.25;
			break;
			case 14:
			player.damage+=10;
			break;
			case 15:
			player.damage+=10;
			break;
		}
		snd_play(sLevelUp,70,0);
		var a=100;
		draw_textmode("Arial",1,40,100);
		
		while(a>0){
			draw_textmode(NULL,0,0,a);
			draw_text("LEVEL UP",screen_size.x/2,screen_size.y/2-200+a,vector(0,0,255));
			a-=time_frame*5;
			wait(1);
		}
	}
}